<?php

namespace rdyescapiacontent\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEVRN_PoliciesTypePolicy ArrayType
 * @subpackage Arrays
 */
class ArrayOfEVRN_PoliciesTypePolicy extends AbstractStructArrayBase
{
    /**
     * The Policy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\Policy[]
     */
    public $Policy;
    /**
     * Constructor method for ArrayOfEVRN_PoliciesTypePolicy
     * @uses ArrayOfEVRN_PoliciesTypePolicy::setPolicy()
     * @param \rdyescapiacontent\StructType\Policy[] $policy
     */
    public function __construct(array $policy = array())
    {
        $this
            ->setPolicy($policy);
    }
    /**
     * Get Policy value
     * @return \rdyescapiacontent\StructType\Policy[]|null
     */
    public function getPolicy()
    {
        return $this->Policy;
    }
    /**
     * This method is responsible for validating the values passed to the setPolicy method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPolicy method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePolicyForArrayConstraintsFromSetPolicy(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEVRN_PoliciesTypePolicyPolicyItem) {
            // validation for constraint: itemType
            if (!$arrayOfEVRN_PoliciesTypePolicyPolicyItem instanceof \rdyescapiacontent\StructType\Policy) {
                $invalidValues[] = is_object($arrayOfEVRN_PoliciesTypePolicyPolicyItem) ? get_class($arrayOfEVRN_PoliciesTypePolicyPolicyItem) : sprintf('%s(%s)', gettype($arrayOfEVRN_PoliciesTypePolicyPolicyItem), var_export($arrayOfEVRN_PoliciesTypePolicyPolicyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Policy property can only contain items of type \rdyescapiacontent\StructType\Policy, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Policy value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\Policy[] $policy
     * @return \rdyescapiacontent\ArrayType\ArrayOfEVRN_PoliciesTypePolicy
     */
    public function setPolicy(array $policy = array())
    {
        // validation for constraint: array
        if ('' !== ($policyArrayErrorMessage = self::validatePolicyForArrayConstraintsFromSetPolicy($policy))) {
            throw new \InvalidArgumentException($policyArrayErrorMessage, __LINE__);
        }
        $this->Policy = $policy;
        return $this;
    }
    /**
     * Add item to Policy value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\Policy $item
     * @return \rdyescapiacontent\ArrayType\ArrayOfEVRN_PoliciesTypePolicy
     */
    public function addToPolicy(\rdyescapiacontent\StructType\Policy $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\Policy) {
            throw new \InvalidArgumentException(sprintf('The Policy property can only contain items of type \rdyescapiacontent\StructType\Policy, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Policy[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapiacontent\StructType\Policy|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapiacontent\StructType\Policy|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapiacontent\StructType\Policy|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapiacontent\StructType\Policy|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapiacontent\StructType\Policy|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Policy
     */
    public function getAttributeName()
    {
        return 'Policy';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\ArrayType\ArrayOfEVRN_PoliciesTypePolicy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
