<?php

namespace rdyescapiacontent\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGuaranteeTypeGuaranteeAccepted ArrayType
 * @subpackage Arrays
 */
class ArrayOfGuaranteeTypeGuaranteeAccepted extends AbstractStructArrayBase
{
    /**
     * The GuaranteeAccepted
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\GuaranteeAccepted[]
     */
    public $GuaranteeAccepted;
    /**
     * Constructor method for ArrayOfGuaranteeTypeGuaranteeAccepted
     * @uses ArrayOfGuaranteeTypeGuaranteeAccepted::setGuaranteeAccepted()
     * @param \rdyescapiacontent\StructType\GuaranteeAccepted[] $guaranteeAccepted
     */
    public function __construct(array $guaranteeAccepted = array())
    {
        $this
            ->setGuaranteeAccepted($guaranteeAccepted);
    }
    /**
     * Get GuaranteeAccepted value
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted[]|null
     */
    public function getGuaranteeAccepted()
    {
        return $this->GuaranteeAccepted;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteeAccepted method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteeAccepted method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteeAcceptedForArrayConstraintsFromSetGuaranteeAccepted(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) {
            // validation for constraint: itemType
            if (!$arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem instanceof \rdyescapiacontent\StructType\GuaranteeAccepted) {
                $invalidValues[] = is_object($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) ? get_class($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem) : sprintf('%s(%s)', gettype($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem), var_export($arrayOfGuaranteeTypeGuaranteeAcceptedGuaranteeAcceptedItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteeAccepted property can only contain items of type \rdyescapiacontent\StructType\GuaranteeAccepted, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\GuaranteeAccepted[] $guaranteeAccepted
     * @return \rdyescapiacontent\ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public function setGuaranteeAccepted(array $guaranteeAccepted = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteeAcceptedArrayErrorMessage = self::validateGuaranteeAcceptedForArrayConstraintsFromSetGuaranteeAccepted($guaranteeAccepted))) {
            throw new \InvalidArgumentException($guaranteeAcceptedArrayErrorMessage, __LINE__);
        }
        $this->GuaranteeAccepted = $guaranteeAccepted;
        return $this;
    }
    /**
     * Add item to GuaranteeAccepted value
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\GuaranteeAccepted $item
     * @return \rdyescapiacontent\ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public function addToGuaranteeAccepted(\rdyescapiacontent\StructType\GuaranteeAccepted $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \rdyescapiacontent\StructType\GuaranteeAccepted) {
            throw new \InvalidArgumentException(sprintf('The GuaranteeAccepted property can only contain items of type \rdyescapiacontent\StructType\GuaranteeAccepted, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteeAccepted[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \rdyescapiacontent\StructType\GuaranteeAccepted|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuaranteeAccepted
     */
    public function getAttributeName()
    {
        return 'GuaranteeAccepted';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
