<?php

namespace rdyescapiacontent\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EVRN_UnitCalendarAvailBatchRSType StructType
 * Meta information extracted from the WSDL
 * - mixed: false
 * @subpackage Structs
 */
class EVRN_UnitCalendarAvailBatchRSType extends EVRN_BaseRSType
{
    /**
     * The UnitCalendarAvails
     * Meta information extracted from the WSDL
     * - choice: UnitCalendarAvails | Errors | Warnings | Success
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\UnitCalendarAvails
     */
    public $UnitCalendarAvails;
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - choice: UnitCalendarAvails | Errors | Warnings | Success
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\ErrorsType
     */
    public $Errors;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - choice: UnitCalendarAvails | Errors | Warnings | Success
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\WarningsType
     */
    public $Warnings;
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - choice: UnitCalendarAvails | Errors | Warnings | Success
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - minOccurs: 0
     * @var \rdyescapiacontent\StructType\SuccessType
     */
    public $Success;
    /**
     * Constructor method for EVRN_UnitCalendarAvailBatchRSType
     * @uses EVRN_UnitCalendarAvailBatchRSType::setUnitCalendarAvails()
     * @uses EVRN_UnitCalendarAvailBatchRSType::setErrors()
     * @uses EVRN_UnitCalendarAvailBatchRSType::setWarnings()
     * @uses EVRN_UnitCalendarAvailBatchRSType::setSuccess()
     * @param \rdyescapiacontent\StructType\UnitCalendarAvails $unitCalendarAvails
     * @param \rdyescapiacontent\StructType\ErrorsType $errors
     * @param \rdyescapiacontent\StructType\WarningsType $warnings
     * @param \rdyescapiacontent\StructType\SuccessType $success
     */
    public function __construct(\rdyescapiacontent\StructType\UnitCalendarAvails $unitCalendarAvails = null, \rdyescapiacontent\StructType\ErrorsType $errors = null, \rdyescapiacontent\StructType\WarningsType $warnings = null, \rdyescapiacontent\StructType\SuccessType $success = null)
    {
        $this
            ->setUnitCalendarAvails($unitCalendarAvails)
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setSuccess($success);
    }
    /**
     * Get UnitCalendarAvails value
     * @return \rdyescapiacontent\StructType\UnitCalendarAvails|null
     */
    public function getUnitCalendarAvails()
    {
        return isset($this->UnitCalendarAvails) ? $this->UnitCalendarAvails : null;
    }
    /**
     * This method is responsible for validating the value passed to the setUnitCalendarAvails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUnitCalendarAvails method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateUnitCalendarAvailsForChoiceConstraintsFromSetUnitCalendarAvails($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'Warnings',
            'Success',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property UnitCalendarAvails can\'t be set as the property %s is already set. Only one property must be set among these properties: UnitCalendarAvails, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set UnitCalendarAvails value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\UnitCalendarAvails $unitCalendarAvails
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailBatchRSType
     */
    public function setUnitCalendarAvails(\rdyescapiacontent\StructType\UnitCalendarAvails $unitCalendarAvails = null)
    {
        // validation for constraint: choice(UnitCalendarAvails, Errors, Warnings, Success)
        if ('' !== ($unitCalendarAvailsChoiceErrorMessage = self::validateUnitCalendarAvailsForChoiceConstraintsFromSetUnitCalendarAvails($unitCalendarAvails))) {
            throw new \InvalidArgumentException($unitCalendarAvailsChoiceErrorMessage, __LINE__);
        }
        if (is_null($unitCalendarAvails) || (is_array($unitCalendarAvails) && empty($unitCalendarAvails))) {
            unset($this->UnitCalendarAvails);
        } else {
            $this->UnitCalendarAvails = $unitCalendarAvails;
        }
        return $this;
    }
    /**
     * Get Errors value
     * @return \rdyescapiacontent\StructType\ErrorsType|null
     */
    public function getErrors()
    {
        return isset($this->Errors) ? $this->Errors : null;
    }
    /**
     * This method is responsible for validating the value passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErrorsForChoiceConstraintsFromSetErrors($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'UnitCalendarAvails',
            'Warnings',
            'Success',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Errors can\'t be set as the property %s is already set. Only one property must be set among these properties: Errors, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Errors value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\ErrorsType $errors
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailBatchRSType
     */
    public function setErrors(\rdyescapiacontent\StructType\ErrorsType $errors = null)
    {
        // validation for constraint: choice(UnitCalendarAvails, Errors, Warnings, Success)
        if ('' !== ($errorsChoiceErrorMessage = self::validateErrorsForChoiceConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsChoiceErrorMessage, __LINE__);
        }
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->Errors);
        } else {
            $this->Errors = $errors;
        }
        return $this;
    }
    /**
     * Get Warnings value
     * @return \rdyescapiacontent\StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return isset($this->Warnings) ? $this->Warnings : null;
    }
    /**
     * This method is responsible for validating the value passed to the setWarnings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWarnings method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateWarningsForChoiceConstraintsFromSetWarnings($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'UnitCalendarAvails',
            'Errors',
            'Success',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Warnings can\'t be set as the property %s is already set. Only one property must be set among these properties: Warnings, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Warnings value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\WarningsType $warnings
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailBatchRSType
     */
    public function setWarnings(\rdyescapiacontent\StructType\WarningsType $warnings = null)
    {
        // validation for constraint: choice(UnitCalendarAvails, Errors, Warnings, Success)
        if ('' !== ($warningsChoiceErrorMessage = self::validateWarningsForChoiceConstraintsFromSetWarnings($warnings))) {
            throw new \InvalidArgumentException($warningsChoiceErrorMessage, __LINE__);
        }
        if (is_null($warnings) || (is_array($warnings) && empty($warnings))) {
            unset($this->Warnings);
        } else {
            $this->Warnings = $warnings;
        }
        return $this;
    }
    /**
     * Get Success value
     * @return \rdyescapiacontent\StructType\SuccessType|null
     */
    public function getSuccess()
    {
        return isset($this->Success) ? $this->Success : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSuccess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccess method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSuccessForChoiceConstraintsFromSetSuccess($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'UnitCalendarAvails',
            'Errors',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Success can\'t be set as the property %s is already set. Only one property must be set among these properties: Success, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Success value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \rdyescapiacontent\StructType\SuccessType $success
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailBatchRSType
     */
    public function setSuccess(\rdyescapiacontent\StructType\SuccessType $success = null)
    {
        // validation for constraint: choice(UnitCalendarAvails, Errors, Warnings, Success)
        if ('' !== ($successChoiceErrorMessage = self::validateSuccessForChoiceConstraintsFromSetSuccess($success))) {
            throw new \InvalidArgumentException($successChoiceErrorMessage, __LINE__);
        }
        if (is_null($success) || (is_array($success) && empty($success))) {
            unset($this->Success);
        } else {
            $this->Success = $success;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \rdyescapiacontent\StructType\EVRN_UnitCalendarAvailBatchRSType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
